wai-extra-3.0.21.0: Provides some basic WAI handlers and middleware.

Safe Haskell | None
Language | Haskell2010

Network.Wai.EventSource

Description

A WAI adapter to the HTML5 Server-Sent Events API.

If running through a proxy like Nginx you might need to add the headers:

    [ ("X-Accel-Buffering", "no"), ("Cache-Control", "no-cache")]

Synopsis

- data ServerEvent
  - = ServerEvent {
    - eventName :: Maybe Builder
    - eventId :: Maybe Builder
    - eventData :: [Builder]
    }
  - | CommentEvent {
    - eventComment :: Builder
    }
  - | RetryEvent {
    - eventRetry :: Int
    }
  - | CloseEvent
- eventSourceAppChan :: Chan ServerEvent -> Application
- eventSourceAppIO :: IO ServerEvent -> Application

# Documentation

data ServerEvent Source #

Type representing a communication over an event stream. This can be an actual event, a comment, a modification to the retry timer, or a special "close" event indicating the server should close the connection.

Constructors

ServerEvent |

Fields

- eventName :: Maybe Builder
- eventId :: Maybe Builder
- eventData :: [Builder]

CommentEvent |

Fields

- eventComment :: Builder

RetryEvent |

Fields

- eventRetry :: Int

CloseEvent |

eventSourceAppChan :: Chan ServerEvent -> Application Source #

Make a new WAI EventSource application reading events from the given channel.

eventSourceAppIO :: IO ServerEvent -> Application Source #

Make a new WAI EventSource application reading events from the given IO action.